//+------------------------------------------------------------------+
//|                                               TradeProcessor.mq5 |
//|                                           Copyright 2014, denkir |
//|                           https://login.mql5.com/ru/users/denkir |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, denkir"
#property link      "https://login.mql5.com/ru/users/denkir"
#property version   "1.00"

//+------------------------------------------------------------------+
//| Inclusions                                                       |
//+------------------------------------------------------------------+
#include <Trade\Trade.mqh>


//+------------------------------------------------------------------+
//| Inputs                                                           |
//+------------------------------------------------------------------+
input uint InpTradePause=150; //  , 
input bool InpIsLogging=true; //  ?

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {

//---
   return INIT_SUCCEEDED;
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {

  }

uint gTransCnt=0;
//---
//+------------------------------------------------------------------+
//|                                                    |
//+------------------------------------------------------------------+
enum ENUM_TRADE_OBJ
  {
   TRADE_OBJ_NULL=0,//  
   //---
   TRADE_OBJ_POSITION=1,   // 
   TRADE_OBJ_ORDER=2,      // 
   TRADE_OBJ_DEAL=3,       // 
   TRADE_OBJ_HIST_ORDER=4, // "" 
  };
//+------------------------------------------------------------------+
//| TradeTransaction function                                        |
//+------------------------------------------------------------------+
void OnTradeTransaction
(
 const MqlTradeTransaction &trans,// 
 const MqlTradeRequest &request,  // 
 const MqlTradeResult &result     // 
 )
  {
//--- 
   Sleep(InpTradePause);

//---  
   if(InpIsLogging)
     {
      //---     
      Print("\n---======---");
      PrintFormat(" : %d",trans.deal);
      PrintFormat(" : %s",EnumToString(trans.deal_type));
      PrintFormat(" : %d",trans.order);
      PrintFormat(" : %s",EnumToString(trans.order_state));
      PrintFormat(" : %s",EnumToString(trans.order_type));
      PrintFormat(": %0."+IntegerToString(_Digits)+"f",trans.price);
      PrintFormat(" Stop Loss: %0."+IntegerToString(_Digits)+"f",trans.price_sl);
      PrintFormat(" Take Profit: %0."+IntegerToString(_Digits)+"f",trans.price_tp);
      PrintFormat("  - : %0."+IntegerToString(_Digits)+"f",trans.price_trigger);
      PrintFormat(" : %s",trans.symbol);
      PrintFormat("   : %s",TimeToString(trans.time_expiration));
      PrintFormat("    : %s",EnumToString(trans.time_type));
      PrintFormat("  : %s",EnumToString(trans.type));
      PrintFormat("  : %0.2f",trans.volume);

      //---   
      if(trans.type==TRADE_TRANSACTION_REQUEST)
        {
         //---    
         Print("\n---======---");
         PrintFormat("  : %s",EnumToString(request.action));
         PrintFormat("  : %s",request.comment);
         PrintFormat("   : %d",request.deviation);
         PrintFormat("  : %s",TimeToString(request.expiration));
         PrintFormat(" : %d",request.magic);
         PrintFormat(" : %d",request.order);
         PrintFormat(": %0."+IntegerToString(_Digits)+"f",request.price);
         PrintFormat(" Stop Loss : %0."+IntegerToString(_Digits)+"f",request.sl);
         PrintFormat(" Take Profit : %0."+IntegerToString(_Digits)+"f",request.tp);
         PrintFormat(" StopLimit : %0."+IntegerToString(_Digits)+"f",request.stoplimit);
         PrintFormat(" : %s",request.symbol);
         PrintFormat(" : %s",EnumToString(request.type));
         PrintFormat("   : %s",EnumToString(request.type_filling));
         PrintFormat("    : %s",EnumToString(request.type_time));
         PrintFormat("  : %0.2f",request.volume);

         //---    
         Print("\n---======---");
         PrintFormat("  : %d",result.retcode);
         PrintFormat(" : %d",result.deal);
         PrintFormat(" : %d",result.order);
         PrintFormat(" : %0.2f",result.volume);
         PrintFormat("  : %0."+IntegerToString(_Digits)+"f",result.price);
         PrintFormat(": %0."+IntegerToString(_Digits)+"f",result.bid);
         PrintFormat(": %0."+IntegerToString(_Digits)+"f",result.ask);
         PrintFormat("  : %s",result.comment);
         PrintFormat(" : %d",result.request_id);
        }
     }
//---

   static ENUM_TRADE_OBJ trade_obj;               //  1-    
   static ENUM_TRADE_REQUEST_ACTIONS last_action; //    1- 

//---
   bool is_to_reset_cnt=false;
   string deal_symbol=trans.symbol;

//---
   if(InpIsLogging)
      PrintFormat("\n : #%d",gTransCnt+1);

//--- ==========   [START]
   switch(trans.type)
     {
      //--- 1)   
      case TRADE_TRANSACTION_REQUEST:
        {
         //---
         last_action=request.action;
         string action_str;

         //---   ?
         switch(last_action)
           {
            //--- )  
            case TRADE_ACTION_DEAL:
              {
               action_str="  ";
               trade_obj=TRADE_OBJ_POSITION;
               break;
              }
            //--- )   
            case TRADE_ACTION_PENDING:
              {
               action_str="  ";
               trade_obj=TRADE_OBJ_ORDER;
               break;
              }
            //--- )  
            case TRADE_ACTION_SLTP:
              {
               trade_obj=TRADE_OBJ_POSITION;
               //---
               StringConcatenate(action_str,request.symbol,":   Stop Loss",
                                 "  Take Profit");

               //---
               break;
              }
            //--- )  
            case TRADE_ACTION_MODIFY:
              {
               action_str="   ";
               trade_obj=TRADE_OBJ_ORDER;
               break;
              }
            //--- )  
            case TRADE_ACTION_REMOVE:
              {
               action_str="  ";
               trade_obj=TRADE_OBJ_ORDER;
               break;
              }
           }
         //---
         if(InpIsLogging)
            Print(" : "+action_str);

         //---
         break;
        }
      //--- 2)      
      case TRADE_TRANSACTION_ORDER_ADD:
        {
         if(InpIsLogging)
           {
            if(trade_obj==TRADE_OBJ_POSITION)
               Print("   : "+
                     EnumToString(trans.order_type));
            //---
            else if(trade_obj==TRADE_OBJ_ORDER)
               Print("   : "+
                     EnumToString(trans.order_type));
           }
         //---
         break;
        }
      //--- 3)       
      case TRADE_TRANSACTION_ORDER_DELETE:
        {
         if(InpIsLogging)
            PrintFormat("    : #%d, "+
                        EnumToString(trans.order_type),trans.order);
         //---     
         break;
        }
      //--- 4)      
      case TRADE_TRANSACTION_HISTORY_ADD:
        {
         if(InpIsLogging)
            PrintFormat("   : #%d, "+
                        EnumToString(trans.order_type),trans.order);

         //---    
         if(trade_obj==TRADE_OBJ_ORDER)
           {
            //---  3- 
            if(gTransCnt==2)
              {
               //---    ,  
               datetime now=TimeCurrent();

               //---     
               HistorySelect(now-PeriodSeconds(PERIOD_H1),now);

               //---     
               CDealInfo myDealInfo;
               int all_deals=HistoryDealsTotal();
               //---
               bool is_found=false;
               for(int deal_idx=all_deals;deal_idx>=0;deal_idx--)
                  if(myDealInfo.SelectByIndex(deal_idx))
                     if(myDealInfo.Order()==trans.order)
                        is_found=true;

               //---    
               if(!is_found)
                 {
                  is_to_reset_cnt=true;
                  //---
                  PrintFormat("  : #%d",trans.order);
                 }
              }
            //---  4- 
            if(gTransCnt==3)
              {
               is_to_reset_cnt=true;
               PrintFormat("  : #%d",trans.order);
              }
           }
         //---     
         break;
        }
      //--- 5)      
      case TRADE_TRANSACTION_DEAL_ADD:
        {
         is_to_reset_cnt=true;
         //---
         ulong deal_ticket=trans.deal;
         ENUM_DEAL_TYPE deal_type=trans.deal_type;
         //---
         if(InpIsLogging)
            PrintFormat("   : #%d, "+EnumToString(deal_type),deal_ticket);

         if(deal_ticket>0)
           {
            datetime now=TimeCurrent();

            //---     
            HistorySelect(now-PeriodSeconds(PERIOD_H1),now);

            //---    
            if(HistoryDealSelect(deal_ticket))
              {
               //---  
               CDealInfo myDealInfo;
               myDealInfo.Ticket(deal_ticket);
               long order=myDealInfo.Order();

               //---  
               ENUM_DEAL_ENTRY  deal_entry=myDealInfo.Entry();
               double deal_vol=0.;
               //---
               if(myDealInfo.InfoDouble(DEAL_VOLUME,deal_vol))
                  if(myDealInfo.InfoString(DEAL_SYMBOL,deal_symbol))
                    {
                     //--- 
                     CPositionInfo myPos;
                     double pos_vol=WRONG_VALUE;
                     //---
                     if(myPos.Select(deal_symbol))
                        pos_vol=myPos.Volume();

                     //---     
                     if(deal_entry==DEAL_ENTRY_IN)
                       {
                        //--- 1)  
                        if(deal_vol==pos_vol)
                           PrintFormat("\n%s:   ",deal_symbol);

                        //--- 2)            
                        else if(deal_vol<pos_vol)
                           PrintFormat("\n%s:    ",deal_symbol);
                       }

                     //---     
                     else if(deal_entry==DEAL_ENTRY_OUT)
                       {
                        if(deal_vol>0.0)
                          {
                           //--- 1)  
                           if(pos_vol==WRONG_VALUE)
                              PrintFormat("\n%s:  ",deal_symbol);

                           //--- 2)           
                           else if(pos_vol>0.0)
                              PrintFormat("\n%s:   ",deal_symbol);
                          }
                       }

                     //---   
                     else if(deal_entry==DEAL_ENTRY_INOUT)
                       {
                        if(deal_vol>0.0)
                           if(pos_vol>0.0)
                              PrintFormat("\n%s:  ",deal_symbol);
                       }
                    }

               //---  
               if(trade_obj==TRADE_OBJ_ORDER)
                  PrintFormat("  : %d",order);
              }
           }

         //---
         break;
        }
      //--- 6)    
      case TRADE_TRANSACTION_POSITION:
        {
         is_to_reset_cnt=true;
         //---
         PrintFormat(" : %s",deal_symbol);
         //---
         if(InpIsLogging)
           {
            PrintFormat("  slop loss: %0."+
                        IntegerToString(_Digits)+"f",trans.price_sl);
            PrintFormat("  take profit: %0."+
                        IntegerToString(_Digits)+"f",trans.price_tp);
           }

         //---
         break;
        }
      //--- 7)     
      case TRADE_TRANSACTION_ORDER_UPDATE:
        {

         //---   1- 
         if(gTransCnt==0)
           {
            trade_obj=TRADE_OBJ_ORDER;
            PrintFormat(" : #%d",trans.order);
           }
         //---   2- 
         if(gTransCnt==1)
           {
            //---   
            if(last_action==TRADE_ACTION_MODIFY)
              {
               PrintFormat("  : #%d",trans.order);
               //---  
               is_to_reset_cnt=true;
              }
            //---   
            if(last_action==TRADE_ACTION_REMOVE)
              {
               PrintFormat("  : #%d",trans.order);

              }
           }
         //---   3- 
         if(gTransCnt==2)
           {
            PrintFormat("   : #%d, "+
                        EnumToString(trans.order_type),trans.order);
            //---  
            is_to_reset_cnt=true;
           }

         //---
         break;
        }
     }
//--- ==========   [END]

//---  
   if(is_to_reset_cnt)
     {
      gTransCnt=0;
      trade_obj=0;
      last_action=-1;
     }
   else
      gTransCnt++;
  }
